//object{Leaf} 

#declare LeafHalf=
// 3D curved FINITE (no CSG) surface created from a mesh of triangles
bicubic_patch {
  type 1 // patch_type (0..1)
  // 0 = Bezier patch, just store the triangular vertices
  // 1 = Bezier patch, store all plane equations defined by
  //       the triangulation of the patch into sub patches
  //       (faster, uses more memory)
   flatness 0 // flatness value
  //       flatness_value = 0.0 to 1.0, with higher values
  //        giving flatter, less smooth results
  u_steps 5 // # of triangles to subdivide (1-5)
  v_steps 5 // # of triangles to subdivide (1-5)
  
  <0,0,0>      <0,.266,.054><-.15,.266,.6> (<-.15,.266,.6>+<.506,.220,.508>)/2 //<.151,.251,.415> 
  <.119,.175,0> <.5,.3,.2><.4,.3,.318> <.506,.220,.508>   
  <.288,.334,0> <.4,.3,.2><.8,.1,.05>  <.7,0,.067>  
  
  (<.288,.234,0>+<.777,.1-.079,0>)/2
                <.777,-.079,0><.8,-.167,0>    <1,-.5,0>
  
  scale <1,.7,1.2>
  
 // various geometric transformation macros
// 
#include "transforms.inc"
 
texture {
           pigment{
                      //colour rgb <0.365,0.533,0.035>/2   filter 0.15  
                   quilted 
                      
                     pigment_map{[0 colour rgb <0.4,0.533,0.035>*.7]
                                [.5 quilted  
                                    pigment_map{[0 colour rgbf <0.38,0.533,0.035,.15>*.6]
                                                [.5 quilted   
                                                    colour_map{[0 colour rgbf <0.365,0.533,0.035,1>*.5]
                                                                [.5 colour rgbf <0.365,0.533,0.035,.9/.3>*.3]
                                                                } 
                                                    scale .5
                                                    Shear_Trans(x, <1,0,0>, <1,0,0>)
                                                    ]
                                                }
                                    scale .5 
                                    Shear_Trans(x, <1.5,.4,0>, <1.5,0,.4>)
                                    ]
                                }
                      scale 3  
                      Shear_Trans(x, <1,.5,0>, <1,0,.5>)
                      warp {
                         black_hole <0,0,0>, 1   
                         strength 2   
                         } 
                   
                   } 
                           
           normal{
              quilted .1  //rotate y*45
                      
                     normal_map{[0 quilted .06]
                                [.5 quilted .05 
                                    normal_map{[0 quilted .04]
                                                [.5 quilted .03  
                                                    normal_map{[0 quilted .02]
                                                                [.5 quilted .001 scale .5 Shear_Trans(x, <2.5,.1,0>, <2.5,0,.1>) ]
                                                                } 
                                                    scale .5
                                                    Shear_Trans(x, <2,.3,0>, <2,0,.3>)
                                                    ]
                                                }
                                    scale .5 
                                    Shear_Trans(x, <1.5,.4,0>, <1.5,0,.4>)
                                    ]
                                }
                      scale 3  
                      Shear_Trans(x, <1,.5,0>, <1,0,.5>)
                      warp {
                         black_hole <0,0,0>, 1   
                         strength 2   
                         }     
                         
           }   
           finish{
              ambient 0 
              diffuse .8
              specular 0.1
              roughness 0.1
                
              //brilliance .5
           }
   }

}

#declare Leaf=union{object{LeafHalf}
                    object{LeafHalf scale -z}
                    }    
                    
                    
//object{Leaf}                    